Code

Merge branch 'jk/parse-object-cached'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset LANGUAGE
48 unset $(perl -e '
49         my @env = keys %ENV;
50         my $ok = join("|", qw(
51                 TRACE
52                 DEBUG
53                 USE_LOOKUP
54                 TEST
55                 .*_TEST
56                 PROVE
57                 VALGRIND
58         ));
59         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
60         print join("\n", @vars);
61 ')
62 GIT_AUTHOR_EMAIL=author@example.com
63 GIT_AUTHOR_NAME='A U Thor'
64 GIT_COMMITTER_EMAIL=committer@example.com
65 GIT_COMMITTER_NAME='C O Mitter'
66 GIT_MERGE_VERBOSITY=5
67 export GIT_MERGE_VERBOSITY
68 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
69 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
70 export EDITOR
72 # Protect ourselves from common misconfiguration to export
73 # CDPATH into the environment
74 unset CDPATH
76 unset GREP_OPTIONS
78 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
79         1|2|true)
80                 echo "* warning: Some tests will not work if GIT_TRACE" \
81                         "is set as to trace on STDERR ! *"
82                 echo "* warning: Please set GIT_TRACE to something" \
83                         "other than 1, 2 or true ! *"
84                 ;;
85 esac
87 # Convenience
88 #
89 # A regexp to match 5 and 40 hexdigits
90 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
91 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
93 # Zero SHA-1
94 _z40=0000000000000000000000000000000000000000
96 # Line feed
97 LF='
98 '
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 # Ignore --quiet under a TAP::Harness. Saying how many tests
131                 # passed without the ok/not ok details is always an error.
132                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133         --with-dashes)
134                 with_dashes=t; shift ;;
135         --no-color)
136                 color=; shift ;;
137         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138                 valgrind=t; verbose=t; shift ;;
139         --tee)
140                 shift ;; # was handled already
141         --root=*)
142                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143                 shift ;;
144         *)
145                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146         esac
147 done
149 if test -n "$color"; then
150         say_color () {
151                 (
152                 TERM=$ORIGINAL_TERM
153                 export TERM
154                 case "$1" in
155                         error) tput bold; tput setaf 1;; # bold red
156                         skip)  tput bold; tput setaf 2;; # bold green
157                         pass)  tput setaf 2;;            # green
158                         info)  tput setaf 3;;            # brown
159                         *) test -n "$quiet" && return;;
160                 esac
161                 shift
162                 printf "%s" "$*"
163                 tput sgr0
164                 echo
165                 )
166         }
167 else
168         say_color() {
169                 test -z "$1" && test -n "$quiet" && return
170                 shift
171                 echo "$*"
172         }
173 fi
175 error () {
176         say_color error "error: $*"
177         GIT_EXIT_OK=t
178         exit 1
181 say () {
182         say_color info "$*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
189 then
190         echo "$test_description"
191         exit 0
192 fi
194 exec 5>&1
195 exec 6<&0
196 if test "$verbose" = "t"
197 then
198         exec 4>&2 3>&1
199 else
200         exec 4>/dev/null 3>/dev/null
201 fi
203 test_failure=0
204 test_count=0
205 test_fixed=0
206 test_broken=0
207 test_success=0
209 test_external_has_tap=0
211 die () {
212         code=$?
213         if test -n "$GIT_EXIT_OK"
214         then
215                 exit $code
216         else
217                 echo >&5 "FATAL: Unexpected exit with code $code"
218                 exit 1
219         fi
222 GIT_EXIT_OK=
223 trap 'die' EXIT
225 # The semantics of the editor variables are that of invoking
226 # sh -c "$EDITOR \"$@\"" files ...
228 # If our trash directory contains shell metacharacters, they will be
229 # interpreted if we just set $EDITOR directly, so do a little dance with
230 # environment variables to work around this.
232 # In particular, quoting isn't enough, as the path may contain the same quote
233 # that we're using.
234 test_set_editor () {
235         FAKE_EDITOR="$1"
236         export FAKE_EDITOR
237         EDITOR='"$FAKE_EDITOR"'
238         export EDITOR
241 test_decode_color () {
242         awk '
243                 function name(n) {
244                         if (n == 0) return "RESET";
245                         if (n == 1) return "BOLD";
246                         if (n == 30) return "BLACK";
247                         if (n == 31) return "RED";
248                         if (n == 32) return "GREEN";
249                         if (n == 33) return "YELLOW";
250                         if (n == 34) return "BLUE";
251                         if (n == 35) return "MAGENTA";
252                         if (n == 36) return "CYAN";
253                         if (n == 37) return "WHITE";
254                         if (n == 40) return "BLACK";
255                         if (n == 41) return "BRED";
256                         if (n == 42) return "BGREEN";
257                         if (n == 43) return "BYELLOW";
258                         if (n == 44) return "BBLUE";
259                         if (n == 45) return "BMAGENTA";
260                         if (n == 46) return "BCYAN";
261                         if (n == 47) return "BWHITE";
262                 }
263                 {
264                         while (match($0, /\033\[[0-9;]*m/) != 0) {
265                                 printf "%s<", substr($0, 1, RSTART-1);
266                                 codes = substr($0, RSTART+2, RLENGTH-3);
267                                 if (length(codes) == 0)
268                                         printf "%s", name(0)
269                                 else {
270                                         n = split(codes, ary, ";");
271                                         sep = "";
272                                         for (i = 1; i <= n; i++) {
273                                                 printf "%s%s", sep, name(ary[i]);
274                                                 sep = ";"
275                                         }
276                                 }
277                                 printf ">";
278                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
279                         }
280                         print
281                 }
282         '
285 nul_to_q () {
286         perl -pe 'y/\000/Q/'
289 q_to_nul () {
290         perl -pe 'y/Q/\000/'
293 q_to_cr () {
294         tr Q '\015'
297 q_to_tab () {
298         tr Q '\011'
301 append_cr () {
302         sed -e 's/$/Q/' | tr Q '\015'
305 remove_cr () {
306         tr '\015' Q | sed -e 's/Q$//'
309 # In some bourne shell implementations, the "unset" builtin returns
310 # nonzero status when a variable to be unset was not set in the first
311 # place.
313 # Use sane_unset when that should not be considered an error.
315 sane_unset () {
316         unset "$@"
317         return 0
320 test_tick () {
321         if test -z "${test_tick+set}"
322         then
323                 test_tick=1112911993
324         else
325                 test_tick=$(($test_tick + 60))
326         fi
327         GIT_COMMITTER_DATE="$test_tick -0700"
328         GIT_AUTHOR_DATE="$test_tick -0700"
329         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
332 # Stop execution and start a shell. This is useful for debugging tests and
333 # only makes sense together with "-v".
335 # Be sure to remove all invocations of this command before submitting.
337 test_pause () {
338         if test "$verbose" = t; then
339                 "$SHELL_PATH" <&6 >&3 2>&4
340         else
341                 error >&5 "test_pause requires --verbose"
342         fi
345 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
347 # This will commit a file with the given contents and the given commit
348 # message.  It will also add a tag with <message> as name.
350 # Both <file> and <contents> default to <message>.
352 test_commit () {
353         file=${2:-"$1.t"}
354         echo "${3-$1}" > "$file" &&
355         git add "$file" &&
356         test_tick &&
357         git commit -m "$1" &&
358         git tag "$1"
361 # Call test_merge with the arguments "<message> <commit>", where <commit>
362 # can be a tag pointing to the commit-to-merge.
364 test_merge () {
365         test_tick &&
366         git merge -m "$1" "$2" &&
367         git tag "$1"
370 # This function helps systems where core.filemode=false is set.
371 # Use it instead of plain 'chmod +x' to set or unset the executable bit
372 # of a file in the working directory and add it to the index.
374 test_chmod () {
375         chmod "$@" &&
376         git update-index --add "--chmod=$@"
379 # Unset a configuration variable, but don't fail if it doesn't exist.
380 test_unconfig () {
381         git config --unset-all "$@"
382         config_status=$?
383         case "$config_status" in
384         5) # ok, nothing to unset
385                 config_status=0
386                 ;;
387         esac
388         return $config_status
391 # Set git config, automatically unsetting it after the test is over.
392 test_config () {
393         test_when_finished "test_unconfig '$1'" &&
394         git config "$@"
397 test_config_global () {
398         test_when_finished "test_unconfig --global '$1'" &&
399         git config --global "$@"
402 # Use test_set_prereq to tell that a particular prerequisite is available.
403 # The prerequisite can later be checked for in two ways:
405 # - Explicitly using test_have_prereq.
407 # - Implicitly by specifying the prerequisite tag in the calls to
408 #   test_expect_{success,failure,code}.
410 # The single parameter is the prerequisite tag (a simple word, in all
411 # capital letters by convention).
413 test_set_prereq () {
414         satisfied="$satisfied$1 "
416 satisfied=" "
418 test_have_prereq () {
419         # prerequisites can be concatenated with ','
420         save_IFS=$IFS
421         IFS=,
422         set -- $*
423         IFS=$save_IFS
425         total_prereq=0
426         ok_prereq=0
427         missing_prereq=
429         for prerequisite
430         do
431                 total_prereq=$(($total_prereq + 1))
432                 case $satisfied in
433                 *" $prerequisite "*)
434                         ok_prereq=$(($ok_prereq + 1))
435                         ;;
436                 *)
437                         # Keep a list of missing prerequisites
438                         if test -z "$missing_prereq"
439                         then
440                                 missing_prereq=$prerequisite
441                         else
442                                 missing_prereq="$prerequisite,$missing_prereq"
443                         fi
444                 esac
445         done
447         test $total_prereq = $ok_prereq
450 test_declared_prereq () {
451         case ",$test_prereq," in
452         *,$1,*)
453                 return 0
454                 ;;
455         esac
456         return 1
459 # You are not expected to call test_ok_ and test_failure_ directly, use
460 # the text_expect_* functions instead.
462 test_ok_ () {
463         test_success=$(($test_success + 1))
464         say_color "" "ok $test_count - $@"
467 test_failure_ () {
468         test_failure=$(($test_failure + 1))
469         say_color error "not ok - $test_count $1"
470         shift
471         echo "$@" | sed -e 's/^/#       /'
472         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
475 test_known_broken_ok_ () {
476         test_fixed=$(($test_fixed+1))
477         say_color "" "ok $test_count - $@ # TODO known breakage"
480 test_known_broken_failure_ () {
481         test_broken=$(($test_broken+1))
482         say_color skip "not ok $test_count - $@ # TODO known breakage"
485 test_debug () {
486         test "$debug" = "" || eval "$1"
489 test_eval_ () {
490         # This is a separate function because some tests use
491         # "return" to end a test_expect_success block early.
492         eval </dev/null >&3 2>&4 "$*"
495 test_run_ () {
496         test_cleanup=:
497         expecting_failure=$2
498         test_eval_ "$1"
499         eval_ret=$?
501         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
502         then
503                 test_eval_ "$test_cleanup"
504         fi
505         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
506                 echo ""
507         fi
508         return "$eval_ret"
511 test_skip () {
512         test_count=$(($test_count+1))
513         to_skip=
514         for skp in $GIT_SKIP_TESTS
515         do
516                 case $this_test.$test_count in
517                 $skp)
518                         to_skip=t
519                         break
520                 esac
521         done
522         if test -z "$to_skip" && test -n "$test_prereq" &&
523            ! test_have_prereq "$test_prereq"
524         then
525                 to_skip=t
526         fi
527         case "$to_skip" in
528         t)
529                 of_prereq=
530                 if test "$missing_prereq" != "$test_prereq"
531                 then
532                         of_prereq=" of $test_prereq"
533                 fi
535                 say_color skip >&3 "skipping test: $@"
536                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
537                 : true
538                 ;;
539         *)
540                 false
541                 ;;
542         esac
545 test_expect_failure () {
546         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
547         test "$#" = 2 ||
548         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
549         export test_prereq
550         if ! test_skip "$@"
551         then
552                 say >&3 "checking known breakage: $2"
553                 if test_run_ "$2" expecting_failure
554                 then
555                         test_known_broken_ok_ "$1"
556                 else
557                         test_known_broken_failure_ "$1"
558                 fi
559         fi
560         echo >&3 ""
563 test_expect_success () {
564         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
565         test "$#" = 2 ||
566         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
567         export test_prereq
568         if ! test_skip "$@"
569         then
570                 say >&3 "expecting success: $2"
571                 if test_run_ "$2"
572                 then
573                         test_ok_ "$1"
574                 else
575                         test_failure_ "$@"
576                 fi
577         fi
578         echo >&3 ""
581 # test_external runs external test scripts that provide continuous
582 # test output about their progress, and succeeds/fails on
583 # zero/non-zero exit code.  It outputs the test output on stdout even
584 # in non-verbose mode, and announces the external script with "# run
585 # <n>: ..." before running it.  When providing relative paths, keep in
586 # mind that all scripts run in "trash directory".
587 # Usage: test_external description command arguments...
588 # Example: test_external 'Perl API' perl ../path/to/test.pl
589 test_external () {
590         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
591         test "$#" = 3 ||
592         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
593         descr="$1"
594         shift
595         export test_prereq
596         if ! test_skip "$descr" "$@"
597         then
598                 # Announce the script to reduce confusion about the
599                 # test output that follows.
600                 say_color "" "# run $test_count: $descr ($*)"
601                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
602                 # to be able to use them in script
603                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
604                 # Run command; redirect its stderr to &4 as in
605                 # test_run_, but keep its stdout on our stdout even in
606                 # non-verbose mode.
607                 "$@" 2>&4
608                 if [ "$?" = 0 ]
609                 then
610                         if test $test_external_has_tap -eq 0; then
611                                 test_ok_ "$descr"
612                         else
613                                 say_color "" "# test_external test $descr was ok"
614                                 test_success=$(($test_success + 1))
615                         fi
616                 else
617                         if test $test_external_has_tap -eq 0; then
618                                 test_failure_ "$descr" "$@"
619                         else
620                                 say_color error "# test_external test $descr failed: $@"
621                                 test_failure=$(($test_failure + 1))
622                         fi
623                 fi
624         fi
627 # Like test_external, but in addition tests that the command generated
628 # no output on stderr.
629 test_external_without_stderr () {
630         # The temporary file has no (and must have no) security
631         # implications.
632         tmp=${TMPDIR:-/tmp}
633         stderr="$tmp/git-external-stderr.$$.tmp"
634         test_external "$@" 4> "$stderr"
635         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
636         descr="no stderr: $1"
637         shift
638         say >&3 "# expecting no stderr from previous command"
639         if [ ! -s "$stderr" ]; then
640                 rm "$stderr"
642                 if test $test_external_has_tap -eq 0; then
643                         test_ok_ "$descr"
644                 else
645                         say_color "" "# test_external_without_stderr test $descr was ok"
646                         test_success=$(($test_success + 1))
647                 fi
648         else
649                 if [ "$verbose" = t ]; then
650                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
651                 else
652                         output=
653                 fi
654                 # rm first in case test_failure exits.
655                 rm "$stderr"
656                 if test $test_external_has_tap -eq 0; then
657                         test_failure_ "$descr" "$@" "$output"
658                 else
659                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
660                         test_failure=$(($test_failure + 1))
661                 fi
662         fi
665 # debugging-friendly alternatives to "test [-f|-d|-e]"
666 # The commands test the existence or non-existence of $1. $2 can be
667 # given to provide a more precise diagnosis.
668 test_path_is_file () {
669         if ! [ -f "$1" ]
670         then
671                 echo "File $1 doesn't exist. $*"
672                 false
673         fi
676 test_path_is_dir () {
677         if ! [ -d "$1" ]
678         then
679                 echo "Directory $1 doesn't exist. $*"
680                 false
681         fi
684 test_path_is_missing () {
685         if [ -e "$1" ]
686         then
687                 echo "Path exists:"
688                 ls -ld "$1"
689                 if [ $# -ge 1 ]; then
690                         echo "$*"
691                 fi
692                 false
693         fi
696 # test_line_count checks that a file has the number of lines it
697 # ought to. For example:
699 #       test_expect_success 'produce exactly one line of output' '
700 #               do something >output &&
701 #               test_line_count = 1 output
702 #       '
704 # is like "test $(wc -l <output) = 1" except that it passes the
705 # output through when the number of lines is wrong.
707 test_line_count () {
708         if test $# != 3
709         then
710                 error "bug in the test script: not 3 parameters to test_line_count"
711         elif ! test $(wc -l <"$3") "$1" "$2"
712         then
713                 echo "test_line_count: line count for $3 !$1 $2"
714                 cat "$3"
715                 return 1
716         fi
719 # This is not among top-level (test_expect_success | test_expect_failure)
720 # but is a prefix that can be used in the test script, like:
722 #       test_expect_success 'complain and die' '
723 #           do something &&
724 #           do something else &&
725 #           test_must_fail git checkout ../outerspace
726 #       '
728 # Writing this as "! git checkout ../outerspace" is wrong, because
729 # the failure could be due to a segv.  We want a controlled failure.
731 test_must_fail () {
732         "$@"
733         exit_code=$?
734         if test $exit_code = 0; then
735                 echo >&2 "test_must_fail: command succeeded: $*"
736                 return 1
737         elif test $exit_code -gt 129 -a $exit_code -le 192; then
738                 echo >&2 "test_must_fail: died by signal: $*"
739                 return 1
740         elif test $exit_code = 127; then
741                 echo >&2 "test_must_fail: command not found: $*"
742                 return 1
743         fi
744         return 0
747 # Similar to test_must_fail, but tolerates success, too.  This is
748 # meant to be used in contexts like:
750 #       test_expect_success 'some command works without configuration' '
751 #               test_might_fail git config --unset all.configuration &&
752 #               do something
753 #       '
755 # Writing "git config --unset all.configuration || :" would be wrong,
756 # because we want to notice if it fails due to segv.
758 test_might_fail () {
759         "$@"
760         exit_code=$?
761         if test $exit_code -gt 129 -a $exit_code -le 192; then
762                 echo >&2 "test_might_fail: died by signal: $*"
763                 return 1
764         elif test $exit_code = 127; then
765                 echo >&2 "test_might_fail: command not found: $*"
766                 return 1
767         fi
768         return 0
771 # Similar to test_must_fail and test_might_fail, but check that a
772 # given command exited with a given exit code. Meant to be used as:
774 #       test_expect_success 'Merge with d/f conflicts' '
775 #               test_expect_code 1 git merge "merge msg" B master
776 #       '
778 test_expect_code () {
779         want_code=$1
780         shift
781         "$@"
782         exit_code=$?
783         if test $exit_code = $want_code
784         then
785                 return 0
786         fi
788         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
789         return 1
792 # test_cmp is a helper function to compare actual and expected output.
793 # You can use it like:
795 #       test_expect_success 'foo works' '
796 #               echo expected >expected &&
797 #               foo >actual &&
798 #               test_cmp expected actual
799 #       '
801 # This could be written as either "cmp" or "diff -u", but:
802 # - cmp's output is not nearly as easy to read as diff -u
803 # - not all diff versions understand "-u"
805 test_cmp() {
806         $GIT_TEST_CMP "$@"
809 # This function can be used to schedule some commands to be run
810 # unconditionally at the end of the test to restore sanity:
812 #       test_expect_success 'test core.capslock' '
813 #               git config core.capslock true &&
814 #               test_when_finished "git config --unset core.capslock" &&
815 #               hello world
816 #       '
818 # That would be roughly equivalent to
820 #       test_expect_success 'test core.capslock' '
821 #               git config core.capslock true &&
822 #               hello world
823 #               git config --unset core.capslock
824 #       '
826 # except that the greeting and config --unset must both succeed for
827 # the test to pass.
829 # Note that under --immediate mode, no clean-up is done to help diagnose
830 # what went wrong.
832 test_when_finished () {
833         test_cleanup="{ $*
834                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
837 # Most tests can use the created repository, but some may need to create more.
838 # Usage: test_create_repo <directory>
839 test_create_repo () {
840         test "$#" = 1 ||
841         error "bug in the test script: not 1 parameter to test-create-repo"
842         repo="$1"
843         mkdir -p "$repo"
844         (
845                 cd "$repo" || error "Cannot setup test environment"
846                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
847                 error "cannot run git init -- have you built things yet?"
848                 mv .git/hooks .git/hooks-disabled
849         ) || exit
852 test_done () {
853         GIT_EXIT_OK=t
855         if test -z "$HARNESS_ACTIVE"; then
856                 test_results_dir="$TEST_DIRECTORY/test-results"
857                 mkdir -p "$test_results_dir"
858                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
860                 cat >>"$test_results_path" <<-EOF
861                 total $test_count
862                 success $test_success
863                 fixed $test_fixed
864                 broken $test_broken
865                 failed $test_failure
867                 EOF
868         fi
870         if test "$test_fixed" != 0
871         then
872                 say_color pass "# fixed $test_fixed known breakage(s)"
873         fi
874         if test "$test_broken" != 0
875         then
876                 say_color error "# still have $test_broken known breakage(s)"
877                 msg="remaining $(($test_count-$test_broken)) test(s)"
878         else
879                 msg="$test_count test(s)"
880         fi
881         case "$test_failure" in
882         0)
883                 # Maybe print SKIP message
884                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
886                 if test $test_external_has_tap -eq 0; then
887                         say_color pass "# passed all $msg"
888                         say "1..$test_count$skip_all"
889                 fi
891                 test -d "$remove_trash" &&
892                 cd "$(dirname "$remove_trash")" &&
893                 rm -rf "$(basename "$remove_trash")"
895                 exit 0 ;;
897         *)
898                 if test $test_external_has_tap -eq 0; then
899                         say_color error "# failed $test_failure among $msg"
900                         say "1..$test_count"
901                 fi
903                 exit 1 ;;
905         esac
908 # Test the binaries we have just built.  The tests are kept in
909 # t/ subdirectory and are run in 'trash directory' subdirectory.
910 if test -z "$TEST_DIRECTORY"
911 then
912         # We allow tests to override this, in case they want to run tests
913         # outside of t/, e.g. for running tests on the test library
914         # itself.
915         TEST_DIRECTORY=$(pwd)
916 fi
917 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
919 if test -n "$valgrind"
920 then
921         make_symlink () {
922                 test -h "$2" &&
923                 test "$1" = "$(readlink "$2")" || {
924                         # be super paranoid
925                         if mkdir "$2".lock
926                         then
927                                 rm -f "$2" &&
928                                 ln -s "$1" "$2" &&
929                                 rm -r "$2".lock
930                         else
931                                 while test -d "$2".lock
932                                 do
933                                         say "Waiting for lock on $2."
934                                         sleep 1
935                                 done
936                         fi
937                 }
938         }
940         make_valgrind_symlink () {
941                 # handle only executables, unless they are shell libraries that
942                 # need to be in the exec-path.  We will just use "#!" as a
943                 # guess for a shell-script, since we have no idea what the user
944                 # may have configured as the shell path.
945                 test -x "$1" ||
946                 test "#!" = "$(head -c 2 <"$1")" ||
947                 return;
949                 base=$(basename "$1")
950                 symlink_target=$GIT_BUILD_DIR/$base
951                 # do not override scripts
952                 if test -x "$symlink_target" &&
953                     test ! -d "$symlink_target" &&
954                     test "#!" != "$(head -c 2 < "$symlink_target")"
955                 then
956                         symlink_target=../valgrind.sh
957                 fi
958                 case "$base" in
959                 *.sh|*.perl)
960                         symlink_target=../unprocessed-script
961                 esac
962                 # create the link, or replace it if it is out of date
963                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
964         }
966         # override all git executables in TEST_DIRECTORY/..
967         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
968         mkdir -p "$GIT_VALGRIND"/bin
969         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
970         do
971                 make_valgrind_symlink $file
972         done
973         # special-case the mergetools loadables
974         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
975         OLDIFS=$IFS
976         IFS=:
977         for path in $PATH
978         do
979                 ls "$path"/git-* 2> /dev/null |
980                 while read file
981                 do
982                         make_valgrind_symlink "$file"
983                 done
984         done
985         IFS=$OLDIFS
986         PATH=$GIT_VALGRIND/bin:$PATH
987         GIT_EXEC_PATH=$GIT_VALGRIND/bin
988         export GIT_VALGRIND
989 elif test -n "$GIT_TEST_INSTALLED" ; then
990         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
991         error "Cannot run git from $GIT_TEST_INSTALLED."
992         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
993         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
994 else # normal case, use ../bin-wrappers only unless $with_dashes:
995         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
996         if ! test -x "$git_bin_dir/git" ; then
997                 if test -z "$with_dashes" ; then
998                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
999                 fi
1000                 with_dashes=t
1001         fi
1002         PATH="$git_bin_dir:$PATH"
1003         GIT_EXEC_PATH=$GIT_BUILD_DIR
1004         if test -n "$with_dashes" ; then
1005                 PATH="$GIT_BUILD_DIR:$PATH"
1006         fi
1007 fi
1008 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1009 unset GIT_CONFIG
1010 GIT_CONFIG_NOSYSTEM=1
1011 GIT_ATTR_NOSYSTEM=1
1012 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1014 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1016 if test -z "$GIT_TEST_CMP"
1017 then
1018         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1019         then
1020                 GIT_TEST_CMP="$DIFF -c"
1021         else
1022                 GIT_TEST_CMP="$DIFF -u"
1023         fi
1024 fi
1026 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1027 export GITPERLLIB
1028 test -d "$GIT_BUILD_DIR"/templates/blt || {
1029         error "You haven't built things yet, have you?"
1032 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1033 then
1034         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1035         export GITPYTHONLIB
1036         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1037                 error "You haven't built git_remote_helpers yet, have you?"
1038         }
1039 fi
1041 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1042         echo >&2 'You need to build test-chmtime:'
1043         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1044         exit 1
1045 fi
1047 # Test repository
1048 test="trash directory.$(basename "$0" .sh)"
1049 test -n "$root" && test="$root/$test"
1050 case "$test" in
1051 /*) TRASH_DIRECTORY="$test" ;;
1052  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1053 esac
1054 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1055 rm -fr "$test" || {
1056         GIT_EXIT_OK=t
1057         echo >&5 "FATAL: Cannot prepare test area"
1058         exit 1
1061 HOME="$TRASH_DIRECTORY"
1062 export HOME
1064 test_create_repo "$test"
1065 # Use -P to resolve symlinks in our working directory so that the cwd
1066 # in subprocesses like git equals our $PWD (for pathname comparisons).
1067 cd -P "$test" || exit 1
1069 this_test=${0##*/}
1070 this_test=${this_test%%-*}
1071 for skp in $GIT_SKIP_TESTS
1072 do
1073         case "$this_test" in
1074         $skp)
1075                 say_color skip >&3 "skipping test $this_test altogether"
1076                 skip_all="skip all tests in $this_test"
1077                 test_done
1078         esac
1079 done
1081 # Provide an implementation of the 'yes' utility
1082 yes () {
1083         if test $# = 0
1084         then
1085                 y=y
1086         else
1087                 y="$*"
1088         fi
1090         while echo "$y"
1091         do
1092                 :
1093         done
1096 # Fix some commands on Windows
1097 case $(uname -s) in
1098 *MINGW*)
1099         # Windows has its own (incompatible) sort and find
1100         sort () {
1101                 /usr/bin/sort "$@"
1102         }
1103         find () {
1104                 /usr/bin/find "$@"
1105         }
1106         sum () {
1107                 md5sum "$@"
1108         }
1109         # git sees Windows-style pwd
1110         pwd () {
1111                 builtin pwd -W
1112         }
1113         # no POSIX permissions
1114         # backslashes in pathspec are converted to '/'
1115         # exec does not inherit the PID
1116         test_set_prereq MINGW
1117         test_set_prereq SED_STRIPS_CR
1118         ;;
1119 *CYGWIN*)
1120         test_set_prereq POSIXPERM
1121         test_set_prereq EXECKEEPSPID
1122         test_set_prereq NOT_MINGW
1123         test_set_prereq SED_STRIPS_CR
1124         ;;
1125 *)
1126         test_set_prereq POSIXPERM
1127         test_set_prereq BSLASHPSPEC
1128         test_set_prereq EXECKEEPSPID
1129         test_set_prereq NOT_MINGW
1130         ;;
1131 esac
1133 test -z "$NO_PERL" && test_set_prereq PERL
1134 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1135 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1136 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1138 # Can we rely on git's output in the C locale?
1139 if test -n "$GETTEXT_POISON"
1140 then
1141         GIT_GETTEXT_POISON=YesPlease
1142         export GIT_GETTEXT_POISON
1143         test_set_prereq GETTEXT_POISON
1144 else
1145         test_set_prereq C_LOCALE_OUTPUT
1146 fi
1148 # Use this instead of test_cmp to compare files that contain expected and
1149 # actual output from git commands that can be translated.  When running
1150 # under GETTEXT_POISON this pretends that the command produced expected
1151 # results.
1152 test_i18ncmp () {
1153         test -n "$GETTEXT_POISON" || test_cmp "$@"
1156 # Use this instead of "grep expected-string actual" to see if the
1157 # output from a git command that can be translated either contains an
1158 # expected string, or does not contain an unwanted one.  When running
1159 # under GETTEXT_POISON this pretends that the command produced expected
1160 # results.
1161 test_i18ngrep () {
1162         if test -n "$GETTEXT_POISON"
1163         then
1164             : # pretend success
1165         elif test "x!" = "x$1"
1166         then
1167                 shift
1168                 ! grep "$@"
1169         else
1170                 grep "$@"
1171         fi
1174 # test whether the filesystem supports symbolic links
1175 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1176 rm -f y
1178 # When the tests are run as root, permission tests will report that
1179 # things are writable when they shouldn't be.
1180 test -w / || test_set_prereq SANITY